unit FmaApiC;

interface

uses
  Windows, FmaDef, FmaApi;

  // Macros to get an api pointer from harea and hmsg
function PAPIFromAreaHandle(harea: TAreaHandle): PAPI;
function PAPIFromMsgHandle(hmsg: TMsgHandle): PAPI;

implementation

/////////////////////////////////////////////////////////////////////////////
// M o d u l e   s p e c i f i c   d e c l a r a t i o n s                 //
/////////////////////////////////////////////////////////////////////////////

  // Generic message area object structure

type
  _XAREA = packed record (* area *)
    magic: ULONG;                     // Magic number (mesage base specific)
    papi: PAPI;                       // Message base api pointer
  end;
  XAREA = _XAREA;
  PXAREA = ^XAREA;

  // Fts message object structure

  PXMSG = ^XMSG;
  XMSG  = packed record (* msg *)
	  pmsgPrev: PXMSG;            // Pointer to prev open msg in area
	  pmsgNext: PXMSG;            // Pointer to next open msg in area
	  magic: ULONG;               // Magic number (mesage base specific)
	  parea: PXAREA;              // Message area handle
  end;
  _XMSG = XMSG;

function PAPIFromAreaHandle(harea: TAreaHandle): PAPI;
begin
  if Assigned(harea) then
  begin
    Result := PXAREA(harea)^.papi;
  end
  else
  begin
    Result := nil;
  end;
end;

function PAPIFromMsgHandle(hmsg: TMsgHandle): PAPI;
begin
  if Assigned(hmsg) and Assigned(PXMSG(hmsg)^.parea) then
  begin
    Result := PXMSG(hmsg)^.parea^.papi;
  end
  else
  begin
    Result := nil;
  end;
end;

end.
