unit FmaApiP;
/////////////////////////////////////////////////////////////////////////////
//
// Fidonet Mail Access: Private header file
//
// FmaApiP.h
//
// Copyright (c) 1999-2000 by Pete Kvitek
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version. See GNU_GPL.TXT for details.
//
// Created: 27/Aug/1999
// Updated: 14/Oct/2002
//
// History: 17/Jan/1999 kvitekp - Initially created for IMA project.
//
//          10/Feb/2000 kvitekp - Added FmaAssertV()
//
//          22/Feb/2000 kvitekp - Added namespace compatibility #ifdefs
//
//          11/Feb/2001 akzhan  - Initially converted to Delphi
//          14/Oct/2002 Plyako A- Declaration of FMAAssertV and FMALogV fixed
//
/////////////////////////////////////////////////////////////////////////////

interface

uses
  Windows, FmaDef; 


/////////////////////////////////////////////////////////////////////////////
// Private data declarations
/////////////////////////////////////////////////////////////////////////////

  // Runtime info structure

type

  _FMARTM = record (* fmaRtm *)
  	nOpenAreas: LONG;                         // Number of open areas
	  csMsgId: TRTLCriticalSection;             // ^aMSGID stamp generation
  end;
  FMARTM = _FMARTM;
  PFMARTM = ^FMARTM;

procedure SETFLAG(var f: LongWord; b: LongWord);
procedure RESETFLAG(var f: LongWord; b: LongWord);
procedure SETFLAGTO(var f: LongWord; b: LongWord; c: LongBool);

{$DEFINE FMA_BREAK_ON_FAILED_ASSERT}

{$IFNDEF FMA_STATIC_LINKAGE}
procedure FmaLogV(pszFormat: PAnsiChar; parg: Tva_list); stdcall;
procedure FmaAssertV(pszFormat: PAnsiChar; parg: Tva_list); stdcall;
{$ENDIF}


implementation

procedure SETFLAG(var f: LongWord; b: LongWord);
begin
  f := f or b;
end;

procedure RESETFLAG(var f: LongWord; b: LongWord);
begin
  f := f and not b;
end;

procedure SETFLAGTO(var f: LongWord; b: LongWord; c: LongBool);
begin
  if c then
  begin
    f := f or b;
  end
  else
  begin
    f := f and not b;
  end;
end;



{$IFNDEF FMA_STATIC_LINKAGE}
procedure FmaLogV(pszFormat: PAnsiChar; parg: Tva_list);
  external FmaDll name 'FmaLogV';
procedure FmaAssertV(pszFormat: PAnsiChar; parg: Tva_list);
  external FmaDll name 'FmaAssertV';
{$ENDIF}

end.
